Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 1412)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 1413)
@@ -48,5 +48,5 @@
 import org.expeditee.core.bounds.PolygonBounds;
 import org.expeditee.encryption.items.surrogates.EncryptionDetail;
-import org.expeditee.encryption.items.surrogates.Surrogate;
+//import org.expeditee.encryption.items.surrogates.Surrogate;
 import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gio.GraphicsManager;
@@ -319,6 +319,25 @@
 
 	private Item surrogateFor = null;
-	private Set<Surrogate> surrogateItems = new HashSet<Surrogate>();
-	private Map<String, EncryptionDetail> propertyEncryption = new HashMap<String, EncryptionDetail>();
+	private Set<Item> surrogateItems = new HashSet<Item>();
+	private static Map<String, EncryptionDetail> classicPropertyEncryptionDefault = new HashMap<String, EncryptionDetail>();
+	private static Map<String, Boolean> surrogatePropertyInheritanceDefault = new HashMap<String, Boolean>();
+	protected Map<String, EncryptionDetail> classicPropertyEncryption = new HashMap<String, EncryptionDetail>(classicPropertyEncryptionDefault);
+	protected Map<String, Boolean> surrogatePropertyInheritance = new HashMap<String, Boolean>(surrogatePropertyInheritanceDefault);
+	
+	{
+		for(Character tag: DefaultFrameWriter.getItemTags().keySet()) {
+			if (tag == 'T' || tag == 'S') {
+				surrogatePropertyInheritanceDefault.put(tag + "", false);
+			} else {
+				surrogatePropertyInheritanceDefault.put(tag + "", true);
+			}
+			classicPropertyEncryptionDefault.put(tag + "", EncryptionDetail.UnencryptedOnSave);
+		}
+		
+		for(String tag: DefaultFrameWriter.getItemTagsExt().keySet()) {
+			surrogatePropertyInheritanceDefault.put(tag, true);
+			classicPropertyEncryptionDefault.put(tag, EncryptionDetail.UnencryptedOnSave);
+		}
+	}
 	
 	/** Just calls source.duplicateOnto(dest). */
@@ -415,10 +434,15 @@
 		_type = type;
 		invalidateAll();
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.DOT_TYPE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DOT_TYPE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.DOT_TYPE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public DotType getDotType() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.DOT_TYPE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.DOT_TYPE_STR)) {
 			return this.getClassic().getDotType();
 		} else {
@@ -428,15 +452,20 @@
 
 	
-	public void setFilled(boolean filled)
-	{
+	public void setFilled(boolean filled) {
 		invalidateAll();
 		_filled = filled;
 		invalidateAll();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.FILLED_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DOT_TYPE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.FILLED_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public boolean getFilled() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.FILLED + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.FILLED_STR)) {
 			return this.getClassic().getFilled();
 		} else {
@@ -450,6 +479,5 @@
 	 * @param gradientAngle The new angle of colour change.
 	 */
-	public void setGradientAngle(double gradientAngle)
-	{
+	public void setGradientAngle(double gradientAngle) {
 		_gradientAngle = gradientAngle;
 
@@ -461,4 +489,12 @@
 		invalidateCommonTrait(ItemAppearence.GradientColor);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.GRADIENT_ANGLE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DOT_TYPE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.GRADIENT_ANGLE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -469,7 +505,5 @@
 	 */
 	public double getGradientAngle() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.GRADIENT_ANGLE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.GRADIENT_ANGLE_STR)) {
 			return this.getClassic().getGradientAngle();
 		} else {
@@ -528,10 +562,16 @@
 			this.getParent().moveItemToBodyHiddenDueToPermission(this);
 		}
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.PERMISSION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DOT_TYPE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.PERMISSION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public PermissionTriple getPermission() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.PERMISSION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.PERMISSION_STR)) {
 			return this.getClassic().getPermission();
 		} else {
@@ -683,7 +723,5 @@
 	 */
 	public List<String> getAction()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_STR)) {
 			return this.getClassic().getAction();
 		} else {
@@ -693,60 +731,48 @@
 
 	public List<String> getData() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.DATA + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.DATA_STR)) {
 			return this.getClassic().getData();
 		} else {
-			return _data.getData();
+			return  _data.getData();
 		}
 	}
 
 	public List<String> getActionCursorEnter() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION_CURSOR_ENTER + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_CURSOR_ENTER_STR)) {
 			return this.getClassic().getActionCursorEnter();
 		} else {
-			return _actionCursorEnter;
+			return  _actionCursorEnter;
 		}
 	}
 
 	public List<String> getActionCursorLeave() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION_CURSOR_LEAVE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_CURSOR_LEAVE_STR)) {
 			return this.getClassic().getActionCursorLeave();
 		} else {
-			return _actionCursorLeave;
+			return  _actionCursorLeave;
 		}
 	}
 
 	public List<String> getActionEnterFrame() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION_ENTER_FRAME + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_ENTER_FRAME_STR)) {
 			return this.getClassic().getActionEnterFrame();
 		} else {
-			return _actionEnterFrame;
+			return  _actionEnterFrame;
 		}
 	}
 
 	public List<String> getActionLeaveFrame() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION_LEAVE_FRAME + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_LEAVE_FRAME_STR)) {
 			return this.getClassic().getActionLeaveFrame();
 		} else {
-			return _actionLeaveFrame;
+			return  _actionLeaveFrame;
 		}
 	}
 
 	public boolean getActionMark() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ACTION_MARK + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ACTION_MARK_STR)) {
 			return this.getClassic().getActionMark();
 		} else {
-			return _actionMark;
+			return  _actionMark;
 		}
 	}
@@ -770,7 +796,5 @@
 
 	public String getArrow() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ARROW + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ARROW_STR)) {
 			return this.getClassic().getArrow();
 		} else {
@@ -807,20 +831,16 @@
 	
 	public Colour getBackgroundColor() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.BACKGROUND_COLOR + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.BACKGROUND_COLOR_STR)) {
 			return this.getClassic().getBackgroundColor();
 		} else {
-			return _backgroundColour;
+			return  _backgroundColour;
 		}
 	}
 
 	public Colour getBorderColor() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.TYPE_AND_ID + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.BORDER_COLOR_STR)) {
 			return this.getClassic().getBorderColor();
 		} else {
-			return _colorBorder;
+			return  _colorBorder;
 		}
 	}
@@ -896,10 +916,8 @@
 
 	public Colour getColor() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.COLOR + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.COLOR_STR)) {
 			return this.getClassic().getColor();
 		} else {
-			return _foregroundColour;
+			return  _foregroundColour;
 		}
 	}
@@ -915,7 +933,5 @@
 
 	public String getConstraintIDs() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.CONSTRAINT_IDS + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.CONSTRAINT_IDS_STR)) {
 			return this.getClassic().getConstraintIDs();
 		} else {
@@ -954,30 +970,24 @@
 
 	public String getDateCreated() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.DATE_CREATED + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.DATE_CREATED_STR)) {
 			return this.getClassic().getDateCreated();
 		} else {
-			return _creationDate;
+			return  _creationDate;
 		}
 	}
 
 	public Colour getFillColor() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.FILL_COLOR + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.FILL_COLOR_STR)) {
 			return this.getClassic().getFillColor();
 		} else {
-			return _fillColour;
+			return  _fillColour;
 		}
 	}
 
 	public String getFillPattern() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.FILL_PATTERN + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.FILL_PATTERN_STR)) {
 			return this.getClassic().getFillPattern();
 		} else {
-			return _fillPattern;
+			return  _fillPattern;
 		}
 	}
@@ -997,10 +1007,8 @@
 	 */
 	public boolean getHighlight() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.HIGHLIGHT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.HIGHLIGHT_STR)) {
 			return this.getClassic().getHighlight();
 		} else {
-			return _highlight;
+			return  _highlight;
 		}
 	}
@@ -1031,7 +1039,5 @@
 	 */
 	public String getLineIDs() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINE_IDS + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINE_IDS_STR)) {
 			return this.getClassic().getLineIDs();
 		} else {
@@ -1050,10 +1056,8 @@
 
 	public int[] getLinePattern() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINE_PATTERN + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINE_PATTERN_STR)) {
 			return this.getClassic().getLinePattern();
 		} else {
-			return _linePattern;
+			return  _linePattern;
 		}
 	}
@@ -1078,20 +1082,16 @@
 	 */
 	public String getLink()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINK + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINK_STR)) {
 			return this.getClassic().getLink();
 		} else {
-			return _link;
+			return  _link;
 		}
 	}
 
 	public String getFormula() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.FORMULA + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.FORMULA_STR)) {
 			return this.getClassic().getFormula();
 		} else {
-			return _formula;
+			return  _formula;
 		}
 	}
@@ -1107,7 +1107,14 @@
 	}
 
-	public void setFormula(String formula)
-	{
+	public void setFormula(String formula) {
 		_formula = formula;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.FORMULA_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.FORMULA_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.FORMULA_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1119,37 +1126,26 @@
 
 	public String getLinkFrameset()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINK_FRAMESET + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINK_FRAMESET_STR)) {
 			return this.getClassic().getLinkFrameset();
 		} else {
-			return _link_frameset;
+			return  _link_frameset;
 		}
 	}
 
 	public boolean getLinkMark() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINK_MARK + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINK_MARK_STR)) {
 			return this.getClassic().getLinkMark();
 		} else {
-			return _linkMark;
+			return  _linkMark;
 		}
 	}
 
 	public String getLinkTemplate()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINK_TEMPLATE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINK_TEMPLATE_STR)) {
 			return this.getClassic().getLinkTemplate();
 		} else {
-			return _link_template;
-		}
-	}
-
-	// public int getMaxWidth()
-	// {
-	// return _maxWidth;
-	// }
+			return  _link_template;
+		}
+	}
 
 	public Point getOffset()
@@ -1159,10 +1155,8 @@
 
 	public String getOwner() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.OWNER + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.OWNER_STR)) {
 			return this.getClassic().getOwner();
 		} else {
-			return _owner;
+			return  _owner;
 		}
 	}
@@ -1281,7 +1275,5 @@
 	/** Gets the position of this item. */
 	public final Point getPosition() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.POSITION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.POSITION_STR)) {
 			return this.getClassic().getPosition();
 		} else {
@@ -1313,7 +1305,5 @@
 
 	public String getTypeAndID() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.TYPE_AND_ID + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.TYPE_AND_ID_STR)) {
 			return this.getClassic().getTypeAndID();
 		} else {
@@ -1323,7 +1313,5 @@
 
 	public Integer getWidthToSave()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.WIDTH_TO_SAVE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.WIDTH_TO_SAVE_STR)) {
 			return this.getClassic().getWidthToSave();
 		} else {
@@ -1333,7 +1321,5 @@
 	
 	public Integer getMinWidthToSave() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MIN_WIDTH_TO_SAVE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR)) {
 			return this.getClassic().getMinWidthToSave();
 		} else {
@@ -1362,7 +1348,5 @@
 	 */
 	public int getX() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.POSITION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.POSITION_STR)) {
 			return this.getClassic().getX();
 		} else {
@@ -1377,7 +1361,5 @@
 	 */
 	public int getY() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.POSITION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.POSITION_STR)) {
 			return this.getClassic().getY();
 		} else {
@@ -1532,15 +1514,20 @@
 	}
 	
-	public void setTooltip(final String tooltip)
-	{
+	public void setTooltip(final String tooltip) {
 		if(tooltip != null && tooltip.trim().length() > 0) {
 			_tooltip.addTooltip(tooltip, this);
 		}
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.TOOLTIP_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TOOLTIP_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.TOOLTIP_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public List<String> getTooltip() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.TOOLTIP + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.TOOLTIP_STR)) {
 			return this.getClassic().getTooltip();
 		} else {
@@ -1824,6 +1811,5 @@
 	 *            The lines of code to associate with this Item
 	 */
-	public void setActions(List<String> actions)
-	{
+	public void setActions(List<String> actions) {
 		if (actions == null || actions.size() == 0) {
 			invalidateCommonTrait(ItemAppearence.LinkChanged);
@@ -1836,4 +1822,12 @@
 		invalidateBounds();
 		invalidateCommonTrait(ItemAppearence.LinkChanged);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1848,4 +1842,12 @@
 	public void addToData(String dataItem) {
 		_data.addToData(dataItem);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.DATA_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DATA_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.DATA_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
@@ -1856,24 +1858,63 @@
 	public void setActionCursorEnter(List<String> enter) {
 		_actionCursorEnter = enter;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_CURSOR_ENTER_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_CURSOR_ENTER_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_CURSOR_ENTER_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public void setActionCursorLeave(List<String> leave) {
 		_actionCursorLeave = leave;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_CURSOR_LEAVE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_CURSOR_LEAVE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_CURSOR_LEAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public void setActionEnterFrame(List<String> enter) {
 		_actionEnterFrame = enter;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_ENTER_FRAME_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_ENTER_FRAME_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_ENTER_FRAME_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public void setActionLeaveFrame(List<String> leave) {
 		_actionLeaveFrame = leave;
-	}
-
-	public void setActionMark(boolean val)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_LEAVE_FRAME_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_LEAVE_FRAME_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_LEAVE_FRAME_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setActionMark(boolean val) {
 		if (!val) invalidateCommonTrait(ItemAppearence.LinkChanged);
 		invalidateBounds();
 		_actionMark = val;
 		if (val) invalidateCommonTrait(ItemAppearence.LinkChanged);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ACTION_MARK_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ACTION_MARK_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ACTION_MARK_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1901,4 +1942,12 @@
 		_arrowheadNibPerc = nib_perc;
 		updateArrowPolygon();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ARROW_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ARROW_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ARROW_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1931,4 +1980,12 @@
 			invalidateCommonTrait(ItemAppearence.BackgroundColorChanged);
 		}
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.BACKGROUND_COLOR_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.BACKGROUND_COLOR_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.BACKGROUND_COLOR_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1937,4 +1994,12 @@
 			_colorBorder = c;
 			invalidateCommonTrait(ItemAppearence.BorderColorChanged);
+		}
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.BORDER_COLOR_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.BORDER_COLOR_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.BORDER_COLOR_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
 		}
 	}
@@ -1970,4 +2035,11 @@
 
 	public void setConstraintIDs(String IDs) {
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.CONSTRAINT_IDS_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.CONSTRAINT_IDS_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.CONSTRAINT_IDS_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1991,4 +2063,12 @@
 	public void setDateCreated(String date) {
 		_creationDate = date;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.DATE_CREATED_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.DATE_CREATED_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.DATE_CREATED_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2006,8 +2086,15 @@
 		invalidateCommonTrait(ItemAppearence.FillColor);
 		invalidateFill();
-	}
-
-	public void setGradientColor(Colour c)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.FILL_COLOR_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.FILL_COLOR_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.FILL_COLOR_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setGradientColor(Colour c) {
 		_gradientColour = c;
 
@@ -2020,10 +2107,16 @@
 		invalidateCommonTrait(ItemAppearence.GradientColor);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.GRADIENT_COLOR_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.GRADIENT_COLOR_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.GRADIENT_COLOR_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public Colour getGradientColor() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.GRADIENT_COLOR + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.GRADIENT_COLOR_STR)) {
 			return this.getClassic().getGradientColor();
 		} else {
@@ -2036,4 +2129,12 @@
 		invalidateCommonTrait(ItemAppearence.FillPattern);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.FILL_PATTERN_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.FILL_PATTERN_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.FILL_PATTERN_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2050,4 +2151,12 @@
 	public void setHighlight(boolean val) {
 		_highlight = val;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.HIGHLIGHT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.HIGHLIGHT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.HIGHLIGHT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2061,4 +2170,12 @@
 	public void setID(int newID) {
 		_id = newID;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.TYPE_AND_ID_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TYPE_AND_ID_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.TYPE_AND_ID_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2070,4 +2187,11 @@
 	 */
 	public void setLineIDs(String lineID) {
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINE_IDS_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINE_IDS_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINE_IDS_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2077,4 +2201,12 @@
 		for (Line line : getLines())
 			line.setLinePattern(pattern);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINE_PATTERN_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINE_PATTERN_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINE_PATTERN_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2094,6 +2226,5 @@
 	 *            The name of the Frame to link this item to.
 	 */
-	public void setLink(String frameName)
-	{
+	public void setLink(String frameName) {
 		if (frameName == null) invalidateCommonTrait(ItemAppearence.LinkChanged);
 
@@ -2110,14 +2241,28 @@
 
 		invalidateCommonTrait(ItemAppearence.LinkChanged);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINK_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINK_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINK_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public void setLinkHistory(boolean value) {
 		_linkHistory = value;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINK_HISTORY_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINK_HISTORY_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINK_HISTORY_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public boolean getLinkHistory() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LINK_HISTORY + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LINK_HISTORY_STR)) {
 			return this.getClassic().getLinkHistory();
 		} else {
@@ -2134,16 +2279,30 @@
 		}
 		// TODO make this throw exceptions etc...
-	}
-
-	public void setLinkMark(boolean val)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINK_FRAMESET_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINK_FRAMESET_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINK_FRAMESET_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setLinkMark(boolean val) {
 		if (!val) invalidateCommonTrait(ItemAppearence.LinkChanged);
 		invalidateBounds();
 		_linkMark = val;
 		if (val) invalidateCommonTrait(ItemAppearence.LinkChanged);
-	}
-
-	public void setLinkTemplate(String template)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINK_MARK_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINK_MARK_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINK_MARK_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setLinkTemplate(String template) {
 		if (FrameIO.isValidLink(template)) {
 			_link_template = template;
@@ -2152,4 +2311,12 @@
 		}
 		// TODO make this throw exceptions etc...
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LINK_TEMPLATE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LINK_TEMPLATE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LINK_TEMPLATE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2178,4 +2345,12 @@
 	public void setOwner(String own) {
 		_owner = own;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.OWNER_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.OWNER_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.OWNER_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
